<?php
/*
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */
require_once '../require.php';
require_once DATA_PATH . "module/Tar.php";
require_once DATA_PATH . 'include/file_manager.inc';

// å
$objSession = new SC_Session();
sfIsSuccess($objSession);

class LC_Page {
    var $tpl_mainpage = 'design/up_down.tpl';
    var $tpl_subnavi  = 'design/subnavi.tpl';
    var $tpl_subno    = 'up_down';
    var $tpl_mainno   = "design";
    var $tpl_subtitle = 'åץ/';

    var $arrErr  = array();
    var $arrForm = array();
}

$objPage = new LC_Page();
$objPage->now_template = lfGetNowTemplate();

// uniqidƥץ졼Ȥ
$objPage->uniqid = $objSession->getUniqId();

switch(lfGetMode()) {

// ɥܥ󲡲ν
case 'download':
    // ܤå
    if (!sfIsValidTransition($objSession)) {
        sfDispError('');
    }
    lfDownloadCreatedFiles();
    exit;
    break;

// åץɥܥ󲡲ν
case 'upload':
    // ܤå
    if (!sfIsValidTransition($objSession)) {
        sfDispError('');
    }
    // եѥ᡼
    $objForm = lfInitUpload();
    // 顼å
    if ($arrErr = lfValidateUpload($objForm)) {
        $objPage->arrErr  = $arrErr;
        $objPage->arrForm = $objForm->getFormParamList();
        break;
    }
    // åץɥե
    $objUpFile = lfInitUploadFile($objForm);
    // ե¸
    $errMsg = $objUpFile->makeTempFile('template_file', false);
    // 񤭹ߥ顼å
    if(isset($errMsg)) {
        $objPage->arrErr['template_file'] = $errMsg;
        $objPage->arrForm = $objForm->getFormParamList();
        break;
    }
    lfAddTemplates($objForm, $objUpFile);
    $objPage->tpl_onload = "alert('ƥץ졼ȥե򥢥åץɤޤ');";
    break;

// ɽ
default:
    break;
}

// ̤ɽ
$objView = new SC_AdminView();
$objView->assignobj($objPage);
$objView->display(MAIN_FRAME);

/**
 * POSTmodeѥ᡼.
 *
 * @param void
 * @return string modeѥ᡼, ̵null
 */
function lfGetMode(){
    if (isset($_POST['mode'])) return $_POST['mode'];
}
/**
 * SC_UploadFile饹ν.
 *
 * @param object $objForm SC_FormParamΥ󥹥
 * @return object SC_UploadFileΥ󥹥
 */
function lfInitUploadFile($objForm) {
    $pkg_dir = TPL_PKG_PATH . $objForm->getValue('template_code');
    $objUpFile = new SC_UploadFile(TEMPLATE_TEMP_DIR, $pkg_dir);
    $objUpFile->addFile("ƥץ졼ȥե", 'template_file', array(), TEMPLATE_SIZE, true, 0, 0, false);

    return $objUpFile;
}
/**
 * SC_FormParam饹ν.
 *
 * @param void
 * @retrun object SC_FormParamΥ󥹥
 */
function lfInitUpload() {
    $objForm = new SC_FormParam;

    $objForm->addParam("ƥץ졼ȥ", "template_code", STEXT_LEN, "KVa", array("EXIST_CHECK","SPTAB_CHECK","MAX_LENGTH_CHECK", "ALNUM_CHECK"));
    $objForm->addParam("ƥץ졼̾", "template_name", STEXT_LEN, "KVa", array("EXIST_CHECK","SPTAB_CHECK","MAX_LENGTH_CHECK"));
    $objForm->setParam($_POST);

    return $objForm;
}
/**
 * upload⡼ɤΥѥ᡼ڤԤ.
 *
 * @param object $objForm SC_FormParamΥ󥹥
 * @return array 顼ǼϢ, 顼̵(¿ʬ)null֤
 */
function lfValidateUpload($objForm) {
    $arrErr = $objForm->checkError();
    if (!empty($arrErr)) {
        return $arrErr;
    }

    $arrForm = $objForm->getHashArray();

    // Ʊ̾Υե¸ߤϥ顼
    if(file_exists(USER_TEMPLATE_PATH . $arrForm['template_code'])) {
        $arrErr['template_code'] = " Ʊ̾Υե뤬Ǥ¸ߤޤ<br/>";
    }

    // ϿԲĤʸå
    $arrIgnoreCode = array(
        'admin', 'mobile', 'default'
    );
    if(in_array($arrForm['template_code'], $arrIgnoreCode)) {
        $arrErr['template_code'] = " Υƥץ졼ȥɤϻѤǤޤ<br/>";
    }

    // DBˤǤϿƤʤå
    $objQuery = new SC_Query();
    $ret = $objQuery->count("dtb_templates", "template_code = ?", array($arrForm['template_code']));
    if(!empty($ret)) {
        $arrErr['template_code'] = " ǤϿƤƥץ졼ȥɤǤ<br/>";
    }

    // եγĥҥå(.tar/tar.gzΤߵ)
    $errFlag = true;
    $array_ext = explode(".", $_FILES['template_file']['name']);
    $ext = $array_ext[ count ( $array_ext ) - 1 ];
    $ext = strtolower($ext);
    // .tarå
    if ($ext == 'tar') {
        $errFlag = false;
    }
    $ext = $array_ext[ count ( $array_ext ) - 2 ].".".$ext;
    $ext = strtolower($ext);
    // .tar.gzå
    if ($ext== 'tar.gz') {
        $errFlag = false;
    }

    if($errFlag) {
        $arrErr['template_file'] = " åץɤƥץ졼ȥեǵĤƤϡtar/tar.gzǤ<br />";
    }

    return $arrErr;
}
/**
 * DBTPL_PKG_PATH˥ƥץ졼ȥѥåɲä.
 *
 * @param object $objForm SC_FormParamΥ󥹥
 * @param object $objUpFile SC_UploadFileΥ󥹥
 * @return void
 */
function lfAddTemplates($objForm, $objUpFile) {
    $template_code = $objForm->getValue('template_code');
    $template_dir = TPL_PKG_PATH . $objForm->getValue('template_code');
    $compile_dir  = COMPILE_DIR . "/$template_code";
    // ե
    mkdir($template_dir);
    mkdir($compile_dir);
    // ե¸ǥ쥯ȥذư
    $objUpFile->moveTempFile();
    // 
    lfUnpacking($template_dir, $_FILES['template_file']['name']);
    // DB˥ƥץ졼Ⱦ¸
    lfRegisterTemplates($objForm->getHashArray());
}
/**
 * åץɤ줿tar֤ह.
 *
 * TODO 狼ˤΤľ,
 * $file_name$objUpFileνTPL_PKG_PATH¸ˤʤäƤ뤿ɬ
 *
 * @param string $dir ǥ쥯ȥ
 * @param strin $file_name ֤Υե̾
 * @return string Archive_Tar::extractModify()Υ顼
 */
function lfUnpacking($dir, $file_name) {

    // ̥ե饰TRUEgzip򤪤ʤ
    $tar = new Archive_Tar("$dir/$file_name", true);

    // ĥҤڤ
    $unpacking_name = preg_replace("/(\.tar|\.tar\.gz)$/", "", $file_name);

    // ꤵ줿ե˲ह
    $err = $tar->extractModify("$dir/", $unpacking_name);

    // ե
    @sfDelFile("$dir/$unpacking_name");
    // ̥ե
    @unlink("$dir/$file_name");

    return $err;
}
/**
 * dtb_templatesƤϿ.
 *
 * @param array $arrForm POST줿ѥ᡼
 * @return void
 */
function lfRegisterTemplates($arrForm) {
    $objQuery = new SC_Query();
    $objQuery->insert('dtb_templates', $arrForm);
}
/**
 * 桼ե򥢡֤ɤ
 * TODO ץե
 * @param void
 * @return void
 */
function lfDownloadCreatedFiles() {
    $dlFileName = 'tpl_package_' . date('YmdHis') . '.tar.gz';
    $tmpDir = TEMPLATE_TEMP_DIR . time() . '/';
    $tmpUserEditDir = $tmpDir . 'user_edit/';

    if (!mkdir($tmpDir)) return ;
    if (!mkdir($tmpDir . 'templates')) return ;
    if (!mkdir($tmpUserEditDir)) return ;

    lfCopyTplPackage($tmpDir);
    lfCopyUserEdit($tmpUserEditDir);

    // ե
    $arrFileHash = sfGetFileList($tmpDir);
    foreach($arrFileHash as $val) {
        $arrFileList[] = $val['file_name'];
    }

    // ǥ쥯ȥư
    chdir($tmpDir);
    // ̤򤪤ʤ
    $tar = new Archive_Tar($dlFileName, true);
    $tar->create($arrFileList);

    // HTTPإå
    header("Content-disposition: attachment; filename=${dlFileName}");
    header("Content-type: application/octet-stream; name=${dlFileName}");
    header("Content-Length: " . filesize($dlFileName));
    readfile($dlFileName);

    // ̥ե
    unlink($dlFileName);
    // ե
    sfDelFile($tmpDir);
}
/**
 * ǥǺ줿եupload/temp_template/ʲ˥ԡ
 *
 * @param string $to
 * @return void
 */
function lfCopyUserEdit($to) {
    $arrDirs = array(
        'css',
        'include',
        'templates'
    );

    foreach ($arrDirs as $dir) {
        $from = USER_PATH .  $dir;
        sfCopyDir($from, $to, '', true);
    }
}
/**
 * 򤷤Ƥƥץ졼ȥѥåupload/temp_template/ʲ˥ԡ
 *
 * @param string $to ¸ѥ
 * @return void
 */
function lfCopyTplPackage($to) {
    $nowTpl = lfGetNowTemplate();
    if (!$nowTpl) return;

    $from = TPL_PKG_PATH . $nowTpl . '/';
    sfCopyDir($from, $to, '');
}
/**
 * ŬѤƤƥץ졼ȥѥå̾.
 *
 * @param void
 * @return string ƥץ졼ȥѥå̾
 */
function lfGetNowTemplate() {
    $objQuery = new SC_Query();
    $arrRet = $objQuery->select('top_tpl', 'dtb_baseinfo');
    if (isset($arrRet[0]['top_tpl'])) {
        return $arrRet[0]['top_tpl'];
    }
    return null;
}

?>
