<?php
/**
 * Copyright(c) 2000-2008 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */

/**
 * ROR Sitemapץȥ ե⥸塼
 * PHP4(PHP5ǤưȻפޤ)
 *
 * (1)⥸塼복
 *    Υ⥸塼 ROR Sitemapץȥб XMLեϤ롣
 *    RORȤResources of a ResourceάǡƤΥ󥸥ФƻȤ륵ȥޥåס
 *    see) http://www.rorweb.com/
 *
 *
 * (2)Υ⥸塼ˤǤ뤳
 *    Υ⥸塼ˤꡢʲΥڡΥȥޥåפ롣
 *    1. $staticURL ǻꤷڡ
 *    2. ̤ΥǥŪڡ
 *    3. Ƥ뤹٤Ƥξʰڡ
 *    4. Ƥ뤹٤Ƥξʾܺ٥ڡ
 * 
 * (3)ˡ
 *    EC-CUBE 󥹥ȡǥ쥯ȥ htmlǥ쥯ȥľ֤뤳Ȥˤư롣
 *    ָ塢metaǰʲΤ褦ϿȡƸ󥸥Υ顼
 *    ưŪ˽褦ˤʤ롣
 *    ex) <link rel="alternate" type="application/rss+xml" title="ROR" href="http://your-site.com/ror.php" />
 *
 *    ޤȥޥåפϿ뤳Ȥˤ, 󥸥Υǥå¥ʤ롣
 *    see) https://www.google.com/webmasters/tools/siteoverview?hl=ja
 *    see) https://siteexplorer.search.yahoo.com/mysites
 *
 * @author Kentaro Ohkouchi
 * @modified Issei Homan
 */

require_once("require.php");
$objSiteInfo = new SC_SiteInfo();

//Ź޾򥻥å
$arrSiteInfo = $objSiteInfo->data;

// ưŪʤڡǻ
$staticURL = array("RSS Feeds" => SITE_URL."rss/index.php");

// ----------------------------------------------------------------------------
// }}}
// {{{ View Logic

/**
 * <item /> .
 *
 * @param string $title      ڡȥ
 * @param string $link       ڡ URL ɬ
 * @param string $desc       סû˾ʰ
 * @param string $descLong   סĹ˾ʾܺ٥ᥤ󥳥
 * @param string $keywords   ޶ڤꥭ comment3
 * @param string $updated    եκǽ YYYY-MM-DD or W3C Datetime 
 * @param string $period     ڡι
 * @param string $image      ᥤ main_image
 * @param string $imageLarge ᥤ main_large_image
 * @param int    $sort       
 * @return Sitemap  <item />
 * see) http://www.rorweb.com/
 */
function createSitemap($title = "", $link, $desc = "", $descLong = "", $keywords = "", $updated = "", $period = "", $image = "", $imageLarge = "", $sort = "") {
    printf("\t<item>\n");
    if (!empty($title)) {
        printf("\t\t<title>%s</title>\n", mb_convert_encoding($title, "UTF-8", "EUC-JP"));
    }
    printf("\t\t<link>%s</link>\n", htmlentities($link, ENT_QUOTES, "UTF-8"));
    if (!empty($desc)) {
        printf("\t\t<description><![CDATA[%s]]></description>\n", mb_convert_encoding($desc, "UTF-8", "EUC-JP"));
    }
    if (!empty($descLong)) {
        printf("\t\t<ror:descLong><![CDATA[%s]]></ror:descLong>\n", mb_convert_encoding($descLong, "UTF-8", "EUC-JP"));
    }
    if (!empty($keywords)) {
        printf("\t\t<ror:keywords><![CDATA[%s]]></ror:keywords>\n", mb_convert_encoding($keywords, "UTF-8", "EUC-JP"));
    }
    if (!empty($updated)) {
        printf("\t\t<ror:updated>%s</ror:updated>\n", $updated);
    }
    if (!empty($period)) {
        printf("\t\t<ror:updatePeriod>%s</ror:updatePeriod>\n", $period);
    }
    if (!empty($image)) {
        printf("\t\t<ror:image>%s</ror:image>\n", $image);
    }
    if (!empty($imageLarge)) {
        printf("\t\t<ror:imageLarge>%s</ror:imageLarge>\n", $imageLarge);
    }
    if(!empty($sort)) {
        printf("\t\t<ror:sortOrder>%d</ror:sortOrder>\n", $sort);
    }
    printf("\t\t<ror:resourceOf>SiteMap</ror:resourceOf>\n");
    printf("\t</item>\n");
}

$objQuery = new SC_Query();

//å夷ʤ(ǰΤ)
header("Paragrama: no-cache");

//XMLƥȽ
header("Content-type: application/xml; charset=utf-8");

// ɬ UTF-8 Ȥƽ
mb_http_output("UTF-8");
ob_start('mb_output_handler');

print("<?xml version='1.0' encoding='UTF-8'?>\n");
print("<rss version='2.0' xmlns:ror='http://rorweb.com/0.1/'>\n");
print("<channel>\n");
print("<title>".mb_convert_encoding($arrSiteInfo['shop_name'], "UTF-8", "EUC-JP")."</title>\n");
print("<link>".$arrSiteInfo['law_url']."/</link>\n");

// ----------------------------------------------------------------------------
// }}}
// {{{ Controller Logic

// Ūʥڡ
foreach($staticURL as $key => $url) {
    createSitemap($key, $url, '', '', '', '', 'daily', '', '', 1);
}
// ڡΥǡ
$objPageData = new LC_PageLayout;

// TOPڡ
$topPage = getTopPage($objPageData->arrPageList);
createSitemap($topPage[0]['page_name'], $topPage[0]['url'], '', '', '', date2W3CDatetime($topPage[0]['update_date']),'daily', '', '', 1);

// Խǽڡ
$editablePages = getEditablePage($objPageData->arrPageList);
foreach($editablePages as $editablePage) {
    createSitemap($editablePage['page_name'], $editablePage['url'], '', '', '', date2W3CDatetime($editablePage['update_date']), '', '', '', 2);
}

// ʰڡ
$products = getAllProducts();
foreach($products as $product) {
    createSitemap($product['title'], $product['url'], '', '', '', '', 'daily', '', '', 2);
}

// ʾܺ٥ڡ
$details = getAllDetail();
foreach($details as $detail) {
    createSitemap($detail['title'], $detail['url'], $detail['desc'], $detail['descLong'], $detail['keywords'], date2W3CDatetime($detail['update_date']), 'weekly', $detail['image'], $detail['imageLarge'], 3);
}

print("</channel>\n");
print("</rss>\n");

// ----------------------------------------------------------------------------
// }}}
// {{{ Model Logic

/**
 * TOPڡξ
 *
 * @param array $pageData ٤ƤΥڡ
 * @return TOPڡξ
 */
function getTopPage($pageData) {
    $arrRet = array();
    foreach($pageData as $page) {
        if ($page['page_id'] == "1") {
            $page['url'] = SITE_URL . $page['url'];
            $arrRet[0] = $page;
            return $arrRet;
        }
    }
}

/**
 * ٤ƤԽǽڡξ.
 *
 * @param array $pageData ٤ƤΥڡ
 * @return Խǽڡ
 */
function getEditablePage($pageData) {
    $arrRet = array();
    $i = 0;
    foreach($pageData as $page) {
        if ($page['page_id'] > 4) {
            $arrRet[$i] = $page;
            $i++;
        }
    }
    return $arrRet;
}

/**
 * dateʸ W3C Datetime ѴƽϤ.
 *
 * @param date $date Ѵ
 */
function date2W3CDatetime($date) {
    $arr = array();
    // ɽʸ
    ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})",
        $date, $arr);
    // :TODO: time zone ٤...
    return sprintf("%04d-%02d-%02dT%02d:%02d:%02d+09:00",
            $arr[1], $arr[2], $arr[3], $arr[4], $arr[5], $arr[6]);
}

// ----------------------------------------------------------------------------
// }}}
// {{{ DB Access Objects

/**
 * ڡǡ򰷤饹.
 */
class LC_PageLayout {

    var $arrPageData;		// ڡǡǼ
    var $arrPageList;		// ڡǡǼ

    /**
     * 󥹥ȥ饯.
     */
    function LC_PageLayout() {
        $this->arrPageList = $this->getPageData();
    }

    /**
     * ֥å.
     *
     * @param string $where WHERE
     * @param array  $arrVal WHEREͤǼ
     * @return ֥å
     */
    function getPageData($where = '', $arrVal = ''){
        $objDBConn = new SC_DbConn;
        $sql = "";
        $arrRet = array();

        // SQL(url  update_date ʳס)
        $sql .= " SELECT";
        $sql .= " page_id";      // ڡID
        $sql .= " ,page_name";   // ̾
        $sql .= " ,url";         // URL
        $sql .= " ,php_dir";     // php¸ǥ쥯ȥ
        $sql .= " ,tpl_dir";     // tpl¸ǥd쥯ȥ
        $sql .= " ,filename";    // ե̾
        $sql .= " ,header_chk "; // إåFLG
        $sql .= " ,footer_chk "; // եåFLG
        $sql .= " ,author";      // author
        $sql .= " ,description"; // description
        $sql .= " ,keyword";     // keyword
        $sql .= " ,update_url";  // URL
        $sql .= " ,create_date"; // ǡ
        $sql .= " ,update_date"; // ǡ
        $sql .= " FROM ";
        $sql .= " dtb_pagelayout";

        // whereλ꤬ɲ
        if ($where != '') {
            $sql .= " WHERE " . $where;
        }

        $sql .= " ORDER BY page_id";

        $arrRet = $objDBConn->getAll($sql, $arrVal);

        $this->arrPageData = $arrRet;

        return $arrRet;
    }
}

/**
 * ٤Ƥξʰڡ.
 *
 * @param boolean $isMobile Хڡ true
 * @return 󥸥󤫤饢ǽʾʰڡξ
 */
function getAllProducts() {
    $conn = new SC_DBConn();
    $sql = "SELECT category_id, category_name FROM dtb_category WHERE del_flg = 0";
    $result = $conn->getAll($sql);

    $arrRet = array();
    for ($i = 0; $i < count($result); $i++) {
        // :TODO: ƥκǽǤ褦ˤ
        $page = array("title" => $result[$i]['category_name'], "url" => SITE_URL . sprintf("products/list.php?category_id=%d", $result[$i]['category_id']));
        $arrRet[$i] = $page;
    }
    return $arrRet;
}

/**
 * ٤Ƥξʾܺ٥ڡ.
 *
 * @param boolean $isMobile Хڡ true
 * @return 󥸥󤫤饢ǽʾʾܺ٥ڡξ
 */
function getAllDetail() {
    $conn = new SC_DBConn();
    $sql = "SELECT product_id, name, comment3, main_comment, main_list_comment, ".
           "main_image, main_large_image, update_date FROM dtb_products ".
           "WHERE del_flg = 0 AND status = 1";
    $result = $conn->getAll($sql);

    $arrRet = array();
    for ($i = 0; $i < count($result); $i++) {
        (file_exists(IMAGE_SAVE_DIR . $result[$i]["main_image"])) ? $dir = IMAGE_SAVE_URL_RSS : $dir = IMAGE_TEMP_URL_RSS;
        $image = $dir . $result[$i]["main_image"];
        (file_exists(IMAGE_SAVE_DIR . $result[$i]["main_large_image"])) ? $dir = IMAGE_SAVE_URL_RSS : $dir = IMAGE_TEMP_URL_RSS;
        $imageLarge = $dir . $result[$i]["main_large_image"];

        $page = array(
            "title"       => $result[$i]['name'],
            "desc"        => $result[$i]['main_list_comment'],
            "descLong"    => $result[$i]['main_comment'],
            "keywords"    => $result[$i]['comment3'],
            "url"         => SITE_URL. sprintf("products/detail.php?product_id=%d", $result[$i]['product_id']),
            "update_date" => $result[$i]['update_date'],
            "image"       => $image,
            "imageLarge"  => $imageLarge
        );
        $arrRet[$i] = $page;
    }
    return $arrRet;
}
?>
