<?php
/**
 * 
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 * 
 */

require_once("../require.php");

class LC_Page {
	var $arrSession;
	var $tpl_mode;
	function LC_Page() {
		$this->tpl_css = '/css/layout/shopping/pay.css';
		$this->tpl_mainpage = 'shopping/payment.tpl';
		$this->tpl_onload = 'fnCheckInputPoint();';
		$this->tpl_title = "ʧˡλ";
		/*
		 session_startno-cacheإå뤳Ȥ
		 ץܥѻͭڤɽ롣
		 private-no-expire:饤ȤΥåĤ롣
		*/
		session_cache_limiter('private-no-expire');		
	}
}

$objPage = new LC_Page();
$objView = new SC_MobileView();
$objSiteSess = new SC_SiteSession();
$objCartSess = new SC_CartSession();
$objCustomer = new SC_Customer();
$objSiteInfo = $objView->objSiteInfo;
$arrInfo = $objSiteInfo->data;

// ѥ᡼饹
$objFormParam = new SC_FormParam();
// ѥ᡼ν
lfInitParam();
// POSTͤμ
$objFormParam->setParam($_POST);

// 桼ˡIDμȹ֤å
$uniqid = sfCheckNormalAccess($objSiteSess, $objCartSess);
// ˡIDѤ
$objPage->tpl_uniqid = $uniqid;

if($objCustomer->isLoginSuccess()) {
    $objPage->tpl_login = '1';
    $objPage->tpl_user_point = $objCustomer->getValue('point');
    //URL
    $objPage->tpl_back_url = URL_DELIV_TOP;
} else {
    $objPage->tpl_back_url = URL_SHOP_TOP . "?from=nonmember";
}


// ۤμ (ڤ줿ˤϤδؿˤƤξʤθĿˤʤ)
$objPage = sfTotalCart($objPage, $objCartSess, $arrInfo);
$objPage->arrData = sfTotalConfirm($arrData, $objPage, $objCartSess, $arrInfo);

// ξʤڤå
$objCartSess->chkSoldOut($objCartSess->getCartList(), true);

// ܥν
if (!empty($_POST['return'])) {
	switch ($_POST['mode']) {
	case 'confirm':
		$_POST['mode'] = 'payment';
		break;
	default:
		// ʿܤǤ뤳ȤϿƤ
		$objSiteSess->setRegistFlag();
		header("Location: " . gfAddSessionId(MOBILE_URL_SHOP_TOP));
		exit;
	}
}

switch($_POST['mode']) {
// ʧˡ  ã
case 'deliv_date':
	
	// ͤѴ
	$objFormParam->convParam();
	$objPage->arrErr = lfCheckError($objPage->arrData);
	if (!isset($objPage->arrErr['payment_id'])) {
		// ʧˡϥ顼ʤ
		$objPage->tpl_mainpage = 'shopping/deliv_date.tpl';
		$objPage->tpl_title = "ã";
		break;
	} else {
		// 桼ˡIDμ
		$uniqid = $objSiteSess->getUniqId();
		// ơ֥뤫ξǼ
		lfSetOrderTempData($uniqid);
	}
	break;
case 'confirm':
	// ͤѴ
	$objFormParam->convParam();
	$objPage->arrErr = lfCheckError($objPage->arrData );
	// ϥ顼ʤ
	if(count($objPage->arrErr) == 0) {
		// DBؤΥǡϿ
		lfRegistData($uniqid);
		// Ͽ줿ȤϿƤ
		$objSiteSess->setRegistFlag();
		// ǧڡذư
		header("Location: " . gfAddSessionId(MOBILE_URL_SHOP_CONFIRM));
		exit;
	}else{
		// 桼ˡIDμ
		$uniqid = $objSiteSess->getUniqId();
		// ơ֥뤫ξǼ
		lfSetOrderTempData($uniqid);
		if (!isset($objPage->arrErr['payment_id'])) {
			// ʧˡϥ顼ʤ
			$objPage->tpl_mainpage = 'shopping/deliv_date.tpl';
			$objPage->tpl_title = "ã";
		}
	}
	break;
// Υڡ
case 'return':
	// ξ
	// ʿܤǤ뤳ȤϿƤ
	$objSiteSess->setRegistFlag();
	header("Location: " . gfAddSessionId(MOBILE_URL_SHOP_TOP));
	exit;
	break;
// ʧˡѹ줿
case 'payment':
	// breakϡ̣Τǳʤǲ
	break;
default:
	// ơ֥뤫ξǼ
	lfSetOrderTempData($uniqid);
	break;
}

// Ź޾μ
$arrInfo = $objSiteInfo->data;
// ۤμ
$total_pretax = $objCartSess->getAllProductsTotal($arrInfo);
// ʧˡμ
$objPage->arrPayment = lfGetPayment($total_pretax);
// ֤μ
$arrRet = sfGetDelivTime($objFormParam->getValue('payment_id'));
$objPage->arrDelivTime = sfArrKeyValue($arrRet, 'time_id', 'deliv_time');
$objPage->objCustomer = $objCustomer;
//μ
$objPage->arrDelivDate = lfGetDelivDate();

$objPage->arrForm = $objFormParam->getFormParamList();

$objView->assignobj($objPage);
$objView->display(SITE_FRAME);
//--------------------------------------------------------------------------------------------------------------------------
/* ѥ᡼ν */
function lfInitParam() {
	global $objFormParam;
	$objFormParam->addParam("ʧˡ", "payment_id", INT_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("ݥ", "use_point", INT_LEN, "n", array("MAX_LENGTH_CHECK", "NUM_CHECK", "ZERO_START"));
	$objFormParam->addParam("ã", "deliv_time_id", INT_LEN, "n", array("MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("", "message", LTEXT_LEN, "KVa", array("SPTAB_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("ݥȤѤ", "point_check", INT_LEN, "n", array("MAX_LENGTH_CHECK", "NUM_CHECK"), '2');
	$objFormParam->addParam("ã", "deliv_date", STEXT_LEN, "KVa", array("MAX_LENGTH_CHECK"));
}

function lfGetPayment($total_pretax) {
	$objQuery = new SC_Query();
	$objQuery->setorder("rank DESC");
	//Ƥʤʧˡ
	$arrRet = $objQuery->select("payment_id, payment_method, rule, upper_rule, note, payment_image", "dtb_payment", "del_flg = 0 AND deliv_id IN (SELECT deliv_id FROM dtb_deliv WHERE del_flg = 0) ");
	//Ѿ狼ʧǽˡȽ
	foreach($arrRet as $data) {
		//¤Ⱦ¤ꤵƤ
		if($data['rule'] > 0 && $data['upper_rule'] > 0) {
			if($data['rule'] <= $total_pretax && $data['upper_rule'] >= $total_pretax) {
				$arrPayment[] = $data;
			}
		//¤ΤꤵƤ
		} elseif($data['rule'] > 0) {	
			if($data['rule'] <= $total_pretax) {
				$arrPayment[] = $data;
			}
		//¤ΤꤵƤ
		} elseif($data['upper_rule'] > 0) {
			if($data['upper_rule'] >= $total_pretax) {
				$arrPayment[] = $data;
			}
		//ʤ
		} else {
			$arrPayment[] = $data;
		}	
	}
	return $arrPayment;	
}

/* ƤΥå */
function lfCheckError($arrData) {
	global $objFormParam;
	global $objCustomer;
	// ϥǡϤ
	$arrRet =  $objFormParam->getHashArray();
	$objErr = new SC_CheckError($arrRet);
	$objErr->arrErr = $objFormParam->checkError();
	
	if($_POST['point_check'] == '1') {
		$objErr->doFunc(array("ݥȤѤ", "point_check"), array("EXIST_CHECK"));
		$objErr->doFunc(array("ݥ", "use_point"), array("EXIST_CHECK"));
		$max_point = $objCustomer->getValue('point');
		if($max_point == "") {
			$max_point = 0;
		}
		if($arrRet['use_point'] > $max_point) {
			$objErr->arrErr['use_point'] = " ѥݥȤݥȤĶƤޤ<br>";
		}
		if(($arrRet['use_point'] * POINT_VALUE) > $arrData['subtotal']) {
			$objErr->arrErr['use_point'] = " ѥݥȤۤĶƤޤ<br>";
		}
	}
	return $objErr->arrErr;
}

/* ʧˡʸμ */
function lfGetPaymentInfo($payment_id) {
	$objQuery = new SC_Query();
	$where = "payment_id = ?";
	$arrRet = $objQuery->select("payment_method, charge", "dtb_payment", $where, array($payment_id));
	return (array($arrRet[0]['payment_method'], $arrRet[0]['charge']));
}

/* ʸμ */
function lfGetDelivTimeInfo($time_id) {
	$objQuery = new SC_Query();
	$where = "time_id = ?";
	$arrRet = $objQuery->select("deliv_id, deliv_time", "dtb_delivtime", $where, array($time_id));
	return (array($arrRet[0]['deliv_id'], $arrRet[0]['deliv_time']));
}

/* DBإǡϿ */
function lfRegistData($uniqid) {
    
	global $objFormParam;
	$arrRet = $objFormParam->getHashArray();
	$sqlval = $objFormParam->getDbArray();
	// Ͽǡκ
	$sqlval['order_temp_id'] = $uniqid;
	$sqlval['update_date'] = 'Now()';
	
	if($sqlval['payment_id'] != "") {
		list($sqlval['payment_method'], $sqlval['charge']) = lfGetPaymentInfo($sqlval['payment_id']);
	} else {
		$sqlval['payment_id'] = '0';
		$sqlval['payment_method'] = "";
	}
	
	if($sqlval['deliv_time_id'] != "") {
		list($sqlval['deliv_id'], $sqlval['deliv_time']) = lfGetDelivTimeInfo($sqlval['deliv_time_id']);
	} else {
		$sqlval['deliv_time_id'] = '0';
		$sqlval['deliv_id'] = '0';
		$sqlval['deliv_time'] = "";
	}
	
	// ѥݥȤ
	if($sqlval['point_check'] != '1') {
		$sqlval['use_point'] = 0;
	}
	
	sfRegistTempOrder($uniqid, $sqlval);
   
}

/* ã */
function lfGetDelivDate() {
	$objCartSess = new SC_CartSession();
	$objQuery = new SC_Query();
	// IDμ
	$max = $objCartSess->getMax();
	for($i = 1; $i <= $max; $i++) {
		if($_SESSION[$objCartSess->key][$i]['id'][0] != "") {
			$arrID['product_id'][$i] = $_SESSION[$objCartSess->key][$i]['id'][0];
		}
	}
	if(count($arrID['product_id']) > 0) {
		$id = implode(",", $arrID['product_id']);
		//ʤȯܰ¤μ
		$deliv_date = $objQuery->get("dtb_products", "MAX(deliv_date_id)", "product_id IN (".$id.")");
		//ȯܰ
		switch($deliv_date) {
		//¨ȯ
		case '1':
			$start_day = 1;
			break;
		//1-2
		case '2':
			$start_day = 3;
			break;
		//3-4
		case '3':
			$start_day = 5;
			break;
		//1ְ
		case '4':
			$start_day = 8;
			break;
		//2ְ
		case '5':
			$start_day = 15;
			break;
		//3ְ
		case '6':
			$start_day = 22;
			break;
		//1
		case '7':
			$start_day = 32;
			break;
		//2ʹ
		case '8':
			$start_day = 62;			
			break;
		//(ٸ)
		case '9':
			$start_day = "";
			break;
		default:
			//ϤꤵƤʤ
			$start_day = "";
			break;
		}
		//ãǽΥͤ顢ã
		$arrDelivDate = lfGetDateArray($start_day, DELIV_DATE_END_MAX);
	}
	return $arrDelivDate;
}

//ãǽΥͤ顢ã
function lfGetDateArray($start_day, $end_day) {
	global $arrWDAY;
	//ãǽΥͤåȤƤ
	if($start_day >= 1) {
		$now_time = time();
		$max_day = $start_day + $end_day;
		// 
		for ($i = $start_day; $i < $max_day; $i++) {
			// ܻ֤ɲäƤ
			$tmp_time = $now_time + ($i * 24 * 3600);
			list($y, $m, $d, $w) = split(" ", date("y m d w", $tmp_time));	
			$val = sprintf("%02d/%02d/%02d(%s)", $y, $m, $d, $arrWDAY[$w]);
			$arrDate[$val] = $val;
		}
	} else {
		$arrDate = false;
	}
	return $arrDate;
}

//ơ֥뤫ξǼ
function lfSetOrderTempData($uniqid) {
	global $objQuery;
	global $objFormParam;
	
	$objQuery = new SC_Query();
	$col = "payment_id, use_point, deliv_time_id, message, point_check, deliv_date";
	$from = "dtb_order_temp";
	$where = "order_temp_id = ?";
	$arrRet = $objQuery->select($col, $from, $where, array($uniqid));
	// DBͤμ
	$objFormParam->setParam($arrRet[0]);
	return $objFormParam;
}


?>
